/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.kandidatenportal;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.kandidatenportal.boundary.AbstractWvpWarnungSearchParameters;
import de.ivu.elect.business.kandidatenportal.boundary.WvpWarnungChangeEvent;
import de.ivu.elect.business.kandidatenportal.boundary.WvpWarnungConversationStore;
import de.ivu.elect.business.kandidatenportal.boundary.WvpWarnungExtendedDAO;
import de.ivu.elect.business.kandidatenportal.boundary.WvpWarnungSearch;
import de.ivu.elect.business.kandidatenportal.boundary.WvpWarnungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.kandidatenportal.entity.WvpWarnung;
import de.ivu.elect.business.kandidatenportal.entity.WvpWarnungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWvpWarnungSearchView.COMPONENT_NAME)
@View(viewId = AbstractWvpWarnungSearchView.VIEW_ID, useCase = UseCasePermission.WVP_WARNUNG_SEARCH)
public abstract class AbstractWvpWarnungSearchView extends AbstractElectSearchView<WvpWarnung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wvpWarnungSearchView";
  
  public static final String VIEW_ID = "/kandidatenportal/wvp-warnung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWvpWarnungSearchView requestHandler;

  @Inject
  private transient WvpWarnungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WvpWarnungConversationStore.class)
  protected transient WvpWarnungConversationStore conversationStore;

  @Inject
  protected transient WvpWarnungSearch search;

  @Inject
  @ConversationGroup(AbstractWvpWarnungSearchParameters.class)
  protected transient WvpWarnungSearchParameters searchParameters;

  @Inject
  protected transient WvpWarnungMeta entityMeta;

  public AbstractWvpWarnungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WvpWarnung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WvpWarnung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WvpWarnungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WvpWarnung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WvpWarnung> create();
  }

  @Override
  public List<WvpWarnung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WvpWarnung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWvpWarnungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WvpWarnungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWvpWarnungSearchView {

    @View
    @Inject
    private transient Instance<AbstractWvpWarnungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWvpWarnungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
